;MeView front-end example v0.1 by Nable-----------------------------------------
;filename for this example is set via commandline because it's an example
;of MV IPC using, not a textbox using example.
use32
org 0
  db 'MENUET01'
  dd 0x01
  dd start
  dd I_END
___memory_size	dd memory_end
  dd mainstack_top
  dd main_commandline
  dd 0x0

include 'macros.inc'   ;size optimisations
include 'ipcstuff.inc'
include 'memory.inc' ;functions in this file are fakes. Don't use them.
include 'subrouts.inc'

;-------------------------------------------------------------------------------
;CODE---------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;I didn't use heap because I still don't understand how does it work in Kolibri
;But to make your life easier I've done everything using fake malloc/realloc/
;/free calls. In your program use real heap operations
start:

  mov ecx,64
  call malloc
;in your program it should be like that:
;
;int pIPCbuffer;
;pIPCbuffer = malloc(64); //allocate not less than 64
;-------------------------------------------------------------------------------

  registerIPCbuffer ipc_buffer, 64
;in your program it should be like that:
;
;registerIPCbuffer(pIPCbuffer,64);
;-------------------------------------------------------------------------------

  build_commandline temp_area, main_commandline
;in your program it should be like that (filename - area with path to targeted
;image file):
;
;char paramline_for_mv[256];
;build_commandline(#paramline_for_mv, #filename);
;-------------------------------------------------------------------------------

  SetEventMask (1 shl (evIPC-1)) ;no comments, if unsure see the code
;-------------------------------------------------------------------------------

  and dword[ipc_buffer],0
;it is used to unlock the buffer, in your program:
;
;DSDWORD[pIPCbuffer]=0
;-------------------------------------------------------------------------------
  mov dword[ipc_buffer+4],8

  RunMV temp_area
;in your program it should be like that:
;
;RunMV(#paramline_for_mv);
;
;Really you can do it in any way you like but don't forget
;about parameters for MeView (i.e. #paramline_for_mv)
;-------------------------------------------------------------------------------

timeout = 20000 ;some images could be processed for a long time
  WaitForEventTimeout (timeout)
  test eax,eax
  jz   ___exit_application
;in your program it should be like that (we can receive only one event, so
;return code can be only 0 (if timeout) or evIPC):
;
;if(!WaitForEventTimeout(3000)) ErrorExit("Timeout!"); //that's all code
;-------------------------------------------------------------------------------

  or  dword[ipc_buffer],1
;it is used to lock the buffer, in your program:
;
;DSDWORD[pIPCbuffer]=1
;-------------------------------------------------------------------------------

;here you must parse the first message from MV
;you can do it in any way you like, but here's my variant (C-code as you like)
  mov eax,[ipc_buffer+8+8]  ;ipc_buffer+8+8 - first message data
  mov [FrameCount],eax
  dec eax		    ;if FrameCount == 1 then:
  jnz @f
  mov esi,(ipc_buffer+8+8+12) ;ipc_buffer+8+8 - first message data
  mov edi,CurrentImage
  movsd 		    ;left and top
  movsd 		    ;width and height
  lodsd
  movzx eax,ax
  mov [BitsPerPixel],eax
@@:			    ;
;-------------------------------------------------------------------------------

;don't forget to allocate additional memory to receive second message (in the
;first message at +8 (i.e. ipc_buffer+8+8+8) the size of second message is located)
  mov ecx,[ipc_buffer+8+8+8]
  add ecx,8192
  call realloc

;in your program:
;int arg0 = DSDWORD[pIPCbuffer+24]+8192;
;Realloc(pIPCbuffer, arg0 );

;then we erase the first message (we don't need it anymore):
;DSDWORD[pIPCbuffer+4]=8;   //pointer to free space in IPC buffer
  mov dword[ipc_buffer+4],8

;then unlock the buffer:
;DSDWORD[pIPCbuffer]=0
  and dword[ipc_buffer],0

  sub ecx,4096 ;some reserve
  registerIPCbuffer ipc_buffer, ecx ;<---------------|
;we have to re-register IPC buffer with the new size.|
;in your program:
;registerIPCbuffer(pIPCbuffer,arg0 - 4096); //arg0 see above

;then we wait for event again
timeout = 400
  WaitForEventTimeout (timeout)
  test eax,eax
  jz   ___exit_application
;in your program it should be like that (we can receive only one event, so
;return code can be only 0 (if timeout) or evIPC):
;
;if(!WaitForEventTimeout(3000)) ErrorExit("Timeout!"); //that's all code

  or  dword[ipc_buffer],1
;lock the buffer, we'll done with IPC for that time. In your program:
;DSDWORD[pIPCbuffer]=1

;if we are here, then we received the second message. if FrameCount==1 then
;it's a pure image data (if BitsPerPixel==24 or 32) or
;(dword)sizeof(palette[]) then palette[] and then the image.
;Parse it as you like, here's my way:
  mov  esi,ipc_buffer+8+8
  cmp  [FrameCount],1 ;if (FrameCount>1)
  ja   .structure_with_multiple_images_came ;then goto .structure_with_multiple_images_came

  and  [pStructureWithImages],0
  cmp  [BitsPerPixel],8 ;if (BitsPerPixel != 8) then we have pure data
  jnz  .single_image_without_palette
;else:
  lodsd
  mov  [CurrentImage.Palette],esi
  add  esi,eax
  mov  [CurrentImage.StartOfImage],esi
  jmp  .second_message_parsed

.single_image_without_palette:
  mov  [CurrentImage.StartOfImage],esi
  and  [CurrentImage.Palette],0
  jmp  .second_message_parsed

.structure_with_multiple_images_came:
  mov  [pStructureWithImages],esi
  and  [CurrentFrameNum],0

  call GetNthImageInfo		    ;see 'subroutines'
.second_message_parsed:
;C-code of this fragment:
;if (FrameCount==1)
; {
;  if(BitsPerPixel != 8)
;   {
;    CurrentImage.Palette=0;
;    CurrentImage.StartOfImage=pIPCbuffer+16
;   }
;  else
;   {
;    int i=pIPCbuffer+16+4;
;    CurrentImage.Palette=i;
;    CurrentImage.StartOfImage=(i+DSDWORD[i-4]);
;   };
; }
;else
; {
;  CurrentFrameNum=0;
;  GetNthImageInfo(pIPCbuffer+16,#CurrentImage,CurrentFrameNum);
; };
;-------------------------------------------------------------------------------
;now you can do everything as you wish. The only thing I want to show you is
;how I handle animation in MeView to avoid blinking. Yeah, I've almost forgotten
;but I animate the picture structure if FrameCount > 1, but may be you want to
;add a button "Start/Stop animation" or even display all frames simulatenously,
;i.e. as AcdSee does, in that case place somewhere BOOL bAnimate; as a flag and
;instead of if(FrameCount > 1) use if((FrameCount > 1) && bAnimate)
  SetEventMask (0111b) ;don't forget to return to a normal event mask

;-------------------------------------------------------------------------------
___MAIN_LOOP:
  mov eax,[FrameCount]
  dec eax
  jz  .no_animation

  mov ebx,CurrentFrameNum ;note that CurrentFrameNum, not a [CurrentFrameNum]
  cmp eax,[ebx]
  ja  @f
  or  dword[ebx],-1	  ;-1+1=0
@@:
  inc dword[ebx]	  ;next frame
  call GetNthImageInfo
  WaitForEventTimeout [CurrentImage.Delay]
  test eax,eax
  jnz .handle_event
  call DrawImage    ;this is anti-blinking: we redraw only client area (in our
		    ;case - image), not the whole window
  jmp ___MAIN_LOOP

.no_animation:
  WaitForEvent

.handle_event:
  dec eax		  ;evRedraw?
  jnz @f
  call DrawWindow
  jmp ___MAIN_LOOP

@@:			  ;no, maybe evKey?
  dec eax
  jnz ___exit_application ;if not, it can be only evButton, we have only 'close' button
  mov al,2
  int 0x40		  ;just read the key and ignore
  jmp ___MAIN_LOOP

;C-code of main loop:
;int event;
;loop()
; {
;  if(FrameCount>1)
;   {
;    CurrentFrameNum++;
;    if(CurrentFrameNum = FrameCount) CurrentFrameNum=0;
;    GetNthImageInfo(pStructureWithImages, #CurrentImage, CurrentFrameNum);
;    event = WaitForEventTimeout(CurrentImage.Delay);
;    DrawImage(); //draw new image. If event == 0 only image is redrawn,
;                 //window won't be redrawn
;   }
;  else
;   {
;    event = WaitForEvent();
;   };
;  switch(event)
;   {
;    case 0: break; //nothing occured, next image
;    case evRedraw: DrawWindow(); break;
;    case evKey: GetKey(); break; //just read and ignore
;    case evButton: ExitApplication(); //we have only one button - "Close"
;   }
; }
;
___exit_application:
  mov  eax,-1
  int  0x40
;-------------------------------------------------------------------------------
;UNINITED DATA------------------------------------------------------------------
;-------------------------------------------------------------------------------
I_END:
struc CurrentImage
{
.Left	      rw 1 ;Don't change the order and the size of
.Right	      rw 1 ;variables from .Left to .Palette.
.Width	      rw 1 ;If you want smth to add here then add it to the end
.Height       rw 1 ;of the structure.
.Delay	      rd 1 ;used for animation. It's how much time current picture
		   ;must be shown (see my code)
.Displacement rd 1 ;I DON'T KNOW WHAT IS IT. Ask Willow.
.StartOfImage rd 1 ;pointer to image data
.Palette      rd 1 ;pointer to palette
}

CurrentImage CurrentImage

pStructureWithImages rd 1 ;pointer to structure with images, use it as you like
FrameCount rd 1 ;it's the total number of images. If it's =1 then we have a
;single image, else we have a structure that contains images, information
;about them, palettes.

CurrentFrameNum rd 1 ;may be in range [0, FrameCount-1]

BitsPerPixel  rd 1  ;it's not included in CurrentImage structure for compatibility
		    ;but you can do it and it'll be good, CurrentFrameNum is also so

main_commandline rb 257

align 32
temp_area:
proc_info: rb 1024

rd  0x400 ;stack
mainstack_top:

align 4096 ;kernel prikols: if not aligned - then we crash. You mustn't care
	   ;about this if you allocate memory via heap functions.
ipc_buffer:
memory_end:

